
import os, time, sys, random, urllib2

import pycurl

#import shared_stuff



'''

Functions that interact with the Dahua camera.

v1.67 of the API is downloadable here:
https://ipcamtalk.com/threads/dahua-http-api.23631/

Good hints on the protocol here too:
https://github.com/nayrnet/node-dahua-api/blob/master/dahua.js

'''


# camera params
camera_ip = "192.168.5.220"
camera_username = "guest"
camera_password = "removed!"

# set to True to debug without a camera
debug_mode = True


 
    
# move the camera    
def ptzMove(direction,speed,action):

    '''
    page 67 of the manual
    
    http://192.168.5.220/cgi-bin/ptz.cgi?action=start&channel=0&code=Up&arg1=0&arg2=2&arg3=0&arg4=0

    http://admin:dapassword@192.168.5.220/cgi-bin/ptz.cgi?action=start&channel=0&code=Up&arg1=0&arg2=2&arg3=0&arg4=0

    Directions:
    Up, Down, Left, Right, LeftUp, RightUp, LeftDown, RightDown

    Actions:
    start, stop

    Speed is 1-8

    '''

    print "direction=%s, action=%s, speed=%s" % (direction, action, speed)

    # action is "start" or "stop"
    
    #url = "http://%s:%s@%s" % (camera_username, camera_password, camera_ip)
    url = "http://%s" % camera_ip
    url += "/cgi-bin/ptz.cgi"
    url += "?action=%s" % action
    url += "&channel=0"
    url += "&code=%s" % direction
    url += "&arg1=%s" % speed # because diagonals have two speed settings
    url += "&arg2=%s" % speed
    url += "&arg3=0"
    url += "&arg4=0"

    #print url

    sendURL(url)


# zoom the camera
def ptzZoom(direction,multiple,action):

    '''

    Not sure what the range of "multiple" is

    Commands are ZoomTele and ZoomWide

    '''

    print "zoom=%s, multiple=%s, action=%s" % (direction, multiple, action)

    url = "http://%s" % camera_ip
    url += "/cgi-bin/ptz.cgi"
    url += "?action=%s" % action
    url += "&channel=0"
    url += "&code=%s" % direction
    url += "&arg1=0" 
    url += "&arg2=%s" % multiple
    url += "&arg3=0"

    sendURL(url)

    #print url



# go to a preset
def presetGo(preset):

    '''

    '/cgi-bin/ptz.cgi?action=start&channel=0&code=GotoPreset&arg1=0&arg2=' + preset + '&arg3=0', f

    '''

    print "go to preset %s" % preset

    url = "http://%s" % camera_ip
    url += "/cgi-bin/ptz.cgi"
    url += "?action=start"
    url += "&channel=0"
    url += "&code=GotoPreset"
    url += "&arg1=0" 
    url += "&arg2=%s" % preset
    url += "&arg3=0"

    sendURL(url)





# send the URL to the camera
def sendURL(url):

    if debug_mode:
        print " (debug mode, command not sent to camera)"
        return # in debug mode, don't bother trying to send to the camera

    '''
    # doesn't work, but from here: https://github.com/mcw0/PoC/blob/master/dahua-backdoor-PoC.py
    pwd_mgr = urllib2.HTTPPasswordMgrWithDefaultRealm()
    pwd_mgr.add_password(None, url, camera_username, camera_password)
    auth_handler = urllib2.HTTPBasicAuthHandler(pwd_mgr)
    opener = urllib2.build_opener(auth_handler)
    urllib2.install_opener(opener)
    request = urllib2.Request(url)
    response = urllib2.urlopen(request)
    #response = urllib2.urlopen(url)
    text = response.read()
    print text

    '''


    try:

        # ugh, can't get urllib2 working. Using method from here: https://github.com/johnnyletrois/dahua-watch/blob/master/watch.py
        CurlObj = pycurl.Curl()
        CurlObj.setopt(pycurl.URL, url)
        CurlObj.setopt(pycurl.CONNECTTIMEOUT, 30)
        CurlObj.setopt(pycurl.TCP_KEEPALIVE, 1)
        CurlObj.setopt(pycurl.TCP_KEEPIDLE, 30)
        CurlObj.setopt(pycurl.TCP_KEEPINTVL, 15)
        CurlObj.setopt(pycurl.HTTPAUTH, pycurl.HTTPAUTH_DIGEST)
        CurlObj.setopt(pycurl.USERPWD, "%s:%s" % (camera_username, camera_password))
        CurlObj.setopt(pycurl.WRITEFUNCTION, onReceiveCallback)

        CurlObj.perform()

    except Exception, e:
        msg = "Error sending command to %s! %s" % (camera_ip, e)
        print msg

    

def onReceiveCallback(response):
    response = response.replace("\n", "")
    response = response.replace("\r", "")
    #response = response.replace("\t", "")
    if response != "OK": 
        print "Response: %s" % response



