#!/usr/bin/python

# -*- coding: utf-8 -*-



'''

To do:

- redo the joystick controls so it starts the command when joystick pressed, and stops when released

'''




import os, time, sys, random, urllib2

import pygame

#from configobj import ConfigObj

import pycurl

#import shared_stuff

from camera_functions import * # camera_functions.py



# the script's current directory
current_directory = os.path.dirname(os.path.realpath(__file__))

# the config file name
config_fname = os.path.abspath(current_directory + "/camera_joystick_configs.txt")








# init pygame
pygame.display.init()



################
# the main loop
################

last_config_lastmod_date = 0
last_config_read_time = 0

joystick_button_states = {}
joystick_hat_states = {}
joystick_axis_states = {}

while True:

    time.sleep(.02)

    '''
    # re-read the config file so it'll reload if the file is changed, but only check every 3 seconds or so
    if time.time() - last_config_read_time > 2: 
        config_lastmod_date = os.path.getmtime(config_fname)
        if config_lastmod_date != last_config_lastmod_date:
            configs = ConfigObj(config_fname, encoding='UTF8')
            last_config_lastmod_date = config_lastmod_date
        last_config_read_time = time.time()
    '''





    #####################     
    # init the joysticks 
    #####################     

    if not pygame.joystick.get_init(): # if it's not initted already, init it
        pygame.joystick.init()
        # init each joystick
        all_joysticks = []
        for j in range( pygame.joystick.get_count() ):
            joystick = pygame.joystick.Joystick(j)
            joystick.init()
            all_joysticks.append(joystick)




    pygame.event.pump()


    ################################
    # iterate through each joystick
    ################################

    joystick_counter = 1
    for joystick in all_joysticks:


        ########
        # hats!
        ########

        num_hats = joystick.get_numhats()
        for i in range( num_hats ):

            value = joystick.get_hat( i )
            #print value

            # up
            name = "joystick=%s hat=%s direction=up" % (joystick_counter, i+1)
            if value == (0,1): joystick_hat_states[name] = True
            else: joystick_hat_states[name] = False

            # down
            name = "joystick=%s hat=%s direction=down" % (joystick_counter, i+1)
            if value == (0,-1): joystick_hat_states[name] = True
            else: joystick_hat_states[name] = False

            # left
            name = "joystick=%s hat=%s direction=left" % (joystick_counter, i+1)
            if value == (-1,0): joystick_hat_states[name] = True
            else: joystick_hat_states[name] = False

            # right
            name = "joystick=%s hat=%s direction=right" % (joystick_counter, i+1)
            if value == (1,0): joystick_hat_states[name] = True
            else: joystick_hat_states[name] = False

            


        ###########
        # buttons!
        ###########
        
        num_buttons = joystick.get_numbuttons()
        for i in range(num_buttons):

            value = joystick.get_button(i)        
            name = "joystick=%s button=%s" % (joystick_counter, i+1)
            if value: joystick_button_states[name] = True
            else: joystick_button_states[name] = False



        

        ########
        # axes!
        ########

        num_axes = joystick.get_numaxes()
        for i in range( num_axes ):

            value = joystick.get_axis( i )
            #print value

            # up
            direction = None
            if i == 0:
                stick_num=1
                low_end = .5 # min value of joystick (was .9)
                high_end = 1.5 # (was 1.1)
                if value < -low_end and value > -high_end: direction = "Left"
                elif value > low_end and direction < high_end: direction = "Right"
            elif i == 1:
                stick_num=1
                if value < -low_end and value > -high_end: direction = "Up"
                elif value > low_end and value < high_end: direction = "Down"
                
            elif i == 2:
                stick_num=2
                if value < -low_end and value > -high_end: direction = "Up"
                elif value > low_end and direction < high_end: direction = "Down"
            elif i == 3:
                stick_num=2
                if value < -low_end and value > -high_end: direction = "Left"
                elif value > low_end and value < high_end: direction = "Right"

            if direction:
                name = "joystick=%s stick=%s direction=%s amount=%s" % ( joystick_counter, stick_num, direction, abs(value) )
                joystick_axis_states[name] = True

        joystick_counter += 1




    #######################################
    # act on the pressed buttons/hats/axis
    #######################################

    # iterate the hat actions
    hat_debounce = .1
    for key, value in joystick_hat_states.iteritems():
        if value:
            print key
            time.sleep(hat_debounce)


    # iterate the button actions
    button_debounce = .3
    for key, value in joystick_button_states.iteritems():
        if value:
            #print key
            params = key.split(" ")
            button = int(params[1].split("=")[1])
            presetGo(button)
            time.sleep(button_debounce)


    # iterate the axes actions
    axes_debounce = 0
    for key, value in joystick_axis_states.iteritems():

        if value:
            #print "key=%s" % key

            # cheesy routing to extract the parameters from the joystick parameters
            # key will be something like joystick=1 stick=1 direction=Down amount=0.999969482422
            params = key.split(" ")
            joystick = int(params[0].split("=")[1])
            stick = int(params[1].split("=")[1])
            direction = params[2].split("=")[1]
            amount = float(params[3].split("=")[1])
            
            #print direction


            if stick==1:

                # our pan stick
                ptzMove(direction,2,"start")
                time.sleep(.5)
                ptzMove(direction,2,"stop")

            elif stick==2:
                
                # our zoom stick
                cmd=None
                if direction == "Up": cmd="ZoomTele"
                elif direction == "Down": cmd="ZoomWide"

                if cmd:
                    ptzZoom(cmd,amount,"start")
                    time.sleep(.3)
                    ptzZoom(cmd,amount,"stop")
                
            

            #%%%
            time.sleep(axes_debounce)

        # need to reset this axis state, otherwise it remains True
        joystick_axis_states[key] = False


    
        
